<TeXmacs|1.0.1>

<style|tmdoc>

<\body>
  <expand|tmdoc-title|Supporting your system inside <apply|TeXmacs>>

  Assume that you have successfully written a first interface with
  <apply|TeXmacs> as explained in the previous section. Then it is time now
  to include support for your system in the standard <apply|TeXmacs>
  distribution, after which further improvements can be made.

  From version 1.0.1.5 on, it has become quite easy to adapt your interface
  in such a way that it can be directly integrated into <TeXmacs>. The idea
  is to create a directories

  <\verbatim>
    \ \ \ \ $TEXMACS_HOME_PATH/plugins/myplugin
  </verbatim>

  where <verbatim|myplugin> is the name of your plugin. Here we recall that
  <verbatim|$TEXMACS_HOME_PATH> is bound to <verbatim|~/.TeXmacs>, by
  default. In the directory <verbatim|$TEXMACS_PATH/plugins> you can find all
  standard plugins, which are shipped with your <TeXmacs> distribution. These
  provide good examples which you may immitate.

  The above <verbatim|myplugin> directory should contain a similar
  subdirectory structure as <verbatim|$TEXMACS_PATH> itself, but you may omit
  directories which you do not actually use. In general, you should in
  particular create the following files:

  <\expand|description-dash>
    <expand|item*|<verbatim|progs/setup-myplugin.scm>>This file is executed
    when you execute <TeXmacs> or a new version of <TeXmacs> for the first
    time. Notice that its execution may be forced by launching <TeXmacs> with
    the <verbatim|--setup> option. The setup program usually consists of the
    lines

    <\verbatim>
      \ \ \ \ (setup-append-if (file-in-path? "myplugin")<format|next line>
      \ \ \ \ \ (exec-file "$GUILE_LOAD_PATH" "init-myplugin.scm"))
    </verbatim>

    This checkes whether the program <verbatim|myplugin> can be executed and,
    if so, forces the execution of <verbatim|init-myplugin.scm> at each next
    run of <TeXmacs>.

    <expand|item*|<verbatim|progs/init-myplugin.scm>>Modulo what has been
    said above, this file will be executed each time when you launch
    <TeXmacs>. This program should make the establish the actual connection
    between <TeXmacs> and your program. This can be done using the
    instructions

    <\verbatim>
      \ \ \ \ (connection-declare "myplugin" "shell-cmd")<format|next line>
      \ \ \ (connection-format "myplugin" "input-format" "output-format")
    </verbatim>

    The first instruction declares your plugin and tells <TeXmacs> that it
    should be launched using <verbatim|shell-cmd>. The command
    <verbatim|shell-cmd> is usually of the form <verbatim|myplugin
    --texmacs>. The second instruction specifies which formats are used for
    the input and output. Usually, the <verbatim|input-format> is
    <verbatim|verbatim> and the <verbatim|output-format> is
    <verbatim|generic>. Other avilable formats are <verbatim|scheme>,
    <verbatim|latex>, <verbatim|html> and <verbatim|ps>.

    All other initializations should also be
    <verbatim|progs/init-myplugin.scm>. For instance, you may want to add the
    lines

    <\verbatim>
      \ \ \ \ (menu-append session-menu<format|next line>
      \ \ \ \ \ ("Myplugin" (make-session "myplugin" "default")))
    </verbatim>

    in order to make your plugin available from the
    <apply|menu|Insert|Session> menu.

    <expand|item*|<verbatim|packages/session/myplugin.ts>>This file contains
    special markup for your plugin. If you want to use your plugin inside
    sessions, then you should define the environments
    <markup|myplugin-session>, <markup|myplugin-input> and
    <markup|myplugin-output> in order to customize the rendering of sessions.
  </expand>

  If everything works well, and you wish to make it possible for others to
  use your system inside the official <apply|TeXmacs> distribution, then
  contact me at <verbatim|vdhoeven@texmacs.org>.

  <apply|tmdoc-copyright|1998--2002|Joris van der Hoeven>

  <expand|tmdoc-license|Permission is granted to copy, distribute and/or
  modify this document under the terms of the GNU Free Documentation License,
  Version 1.1 or any later version published by the Free Software Foundation;
  with no Invariant Sections, with no Front-Cover Texts, and with no
  Back-Cover Texts. A copy of the license is included in the section entitled
  "GNU Free Documentation License".>
</body>

<\initial>
  <\collection>
    <associate|paragraph width|150mm>
    <associate|odd page margin|30mm>
    <associate|shrinking factor|4>
    <associate|page right margin|30mm>
    <associate|page top margin|30mm>
    <associate|reduction page right margin|25mm>
    <associate|page type|a4>
    <associate|reduction page bottom margin|15mm>
    <associate|even page margin|30mm>
    <associate|reduction page left margin|25mm>
    <associate|page bottom margin|30mm>
    <associate|reduction page top margin|15mm>
    <associate|language|english>
  </collection>
</initial>

<\references>
  <\collection>
    <associate|idx-5|<tuple|4.|?>>
    <associate|toc-1|<tuple|<uninit>|?>>
    <associate|idx-1|<tuple|<uninit>|?>>
    <associate|toc-2|<tuple|<uninit>|?>>
    <associate|idx-2|<tuple|<uninit>|?>>
    <associate|idx-3|<tuple|<uninit>|?>>
    <associate|idx-4|<tuple|<uninit>|?>>
  </collection>
</references>

<\auxiliary>
  <\collection>
    <\associate|idx>
      <tuple|<tuple|<with|font family|<quote|ss>|Insert>|<with|font
      family|<quote|ss>|Session>>|<pageref|idx-1>>

      <tuple|<tuple|<with|font family|<quote|tt>|color|<quote|dark
      green>|myplugin-session>>|<pageref|idx-2>>

      <tuple|<tuple|<with|font family|<quote|tt>|color|<quote|dark
      green>|myplugin-input>>|<pageref|idx-3>>

      <tuple|<tuple|<with|font family|<quote|tt>|color|<quote|dark
      green>|myplugin-output>>|<pageref|idx-4>>
    </associate>
  </collection>
</auxiliary>
