
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; MODULE      : format-menu.scm
;; DESCRIPTION : menus for setting local formatting properties
;; COPYRIGHT   : (C) 1999  Joris van der Hoeven
;;
;; This software falls under the GNU general public license and comes WITHOUT
;; ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for details.
;; If you don't have this file, write to the Free Software Foundation, Inc.,
;; 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; The Font submenu in text mode
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(menu-bind text-font-menu
  (-> "Name"
      ("Roman" (make-with "font" "roman"))
      (if (tex-file-exists? "pnr10.mf")
	  ("Pandora" (make-with "font" "pandora")))
      (if (tex-file-exists? "ccr10.mf")
	  ("Concrete" (make-with "font" "concrete")))
      ---
      (-> "Adobe"
	  (if (tex-file-exists? "rpagk.tfm")
	      ("Avant Garde" (make-with "font" "avant-garde")))
	  (if (tex-file-exists? "rpbkl.tfm")
	      ("Bookman" (make-with "font" "bookman")))
	  (if (tex-file-exists? "rpzcmi.tfm")
	      ("Chancery" (make-with "font" "chancery")))
	  (if (tex-file-exists? "rpcrr.tfm")
	      ("Courier" (make-with "font" "courier")))
	  (if (tex-file-exists? "rpzdr.tfm")
	      ("Dingbat" (make-with "font" "dingbat")))
	  (if (tex-file-exists? "rphvr.tfm")
	      ("Helvetica" (make-with "font" "helvetica")))
	  (if (tex-file-exists? "rpncr.tfm")
	      ("New Century Schoolbook"
	       (make-with "font" "new-century-schoolbook")))
	  (if (tex-file-exists? "rpplr.tfm")
	      ("Palatino" (make-with "font" "palatino")))
	  (if (tex-file-exists? "rptmr.tfm")
	      ("Times" (make-with "font" "times"))))
      (-> "Latin"
	  (if (tex-file-exists? "callig15.mf")
	      ("Calligraphic" (make-with "font" "calligraphic")))
	  (if (tex-file-exists? "capbas.mf")
	      ("Capbas" (make-with "font" "capbas")))
	  (if (tex-file-exists? "cdr10.mf")
	      ("Duerer" (make-with "font" "duerer")))
	  (if (tex-file-exists? "hscs10.mf")
	      ("Hershey" (make-with "font" "hershey")))
	  (if (tex-file-exists? "la14.mf")
	      ("La" (make-with "font" "la")))
	  (if (tex-file-exists? "cmfi10.mf")
	      ("Messy" (make-with "font" "messy")))
	  (if (tex-file-exists? "ocr10.mf")
	      ("Optical" (make-with "font" "optical")))
	  (if (tex-file-exists? "cpcr10.mf")
	      ("Pacioli" (make-with "font" "pacioli")))
	  (if (tex-file-exists? "punk20.mf")
	      ("Punk" (make-with "font" "punk")))
	  (if (tex-file-exists? "twcal14.mf")
	      ("Tw#Calligraphic" (make-with "font" "twcal")))
	  (if (tex-file-exists? "va14.mf")
	      ("Va" (make-with "font" "va"))))
      (-> "Gothic"
	  (if (tex-file-exists? "blackletter.mf")
	      ("Blackletter" (make-with "font" "blackletter")))
	  (if (tex-file-exists? "eufm10.mf")
	      ("Euler" (make-with "font" "Euler")))
	  (if (tex-file-exists? "ygoth.mf")
	      ("Gothic" (make-with "font" "gothic")))
	  (if (tex-file-exists? "hge.mf")
	      ("Old English" (make-with "font" "old-english")))
	  (if (tex-file-exists? "schwell.mf")
	      ("Schwell" (make-with "font" "schwell")))
	  (if (tex-file-exists? "suet14.mf")
	      ("Suet" (make-with "font" "suet")))
	  (if (tex-file-exists? "yswab.mf")
	      ("Swab" (make-with "font" "swab"))))
      (-> "Foreign"
	  (if (tex-file-exists? "nash14.mf")
	      ("Arab" (make-with "font" "arab")))
	  (if (tex-file-exists? "artmr10.mf")
	      ("Armenian" (make-with "font" "armenian")))
	  ("Cyrillic" (make-with "font" "cyrillic"))
	  (if (tex-file-exists? "dvng10.mf")
	      ("Devangari" (make-with "font" "devangari")))
	  (if (tex-file-exists? "mxed.mf")
	      (-> "Georgian"
		  ("Mxedruli" (make-with "font" "mxedruli"))
		  ("Xucuri" (make-with "font" "xucuri"))))
	  (if (tex-file-exists? "grmn.mf")
	      ("Greek" (make-with "font" "greek")))
	  (if (tex-file-exists? "redis.mf")
	      ("Hebrew" (make-with "font" "hebrew")))
	  (if (tex-file-exists? "imr10.mf")
	      ("Icelandic" (make-with "font" "icelandic")))
	  (if (tex-file-exists? "eiadr10.mf")
	      ("Irish" (make-with "font" "irish")))
	  (if (tex-file-exists? "osmanian.mf")
	      ("Osmanian" (make-with "font" "osmanian")))
	  (if (tex-file-exists? "wtkr10.mf")
	      ("Turkish" (make-with "font" "turkish")))
	  (if (tex-file-exists? "wntml10.mf")
	      ("Tamil" (make-with "font" "tamil")))
	  (if (tex-file-exists? "thairz10.mf")
	      ("Thai" (make-with "font" "thai")))
	  (if (tex-file-exists? "vmr10.mf")
	      ("Vietnamese" (make-with "font" "vietnamese"))))
      (-> "Archaic"
	  (if (tex-file-exists? "bard.mf")
	      ("Bard" (make-with "font" "bard")))
	  (if (tex-file-exists? "cypr10.mf")
	      ("Cypriot" (make-with "font" "cypriot")))
	  (if (tex-file-exists? "etr10.mf")
	      ("Etruscan" (make-with "font" "etruscan")))
	  (if (tex-file-exists? "givbc10.mf")
	      (-> "Greek"
		  ("4tH Century BC" (make-with "font" "greek4cbc"))
		  ("6th Century BC" (make-with "font" "greek6cbc"))))
	  (if (tex-file-exists? "linb10.mf")
	      ("Linear Beta" (make-with "font" "linearb")))
	  (if (tex-file-exists? "ogham.mf")
	      ("Ogham" (make-with "font" "ogham")))
	  (if (tex-file-exists? "phnc10.mf")
	      ("Phoenician" (make-with "font" "phoenician")))
	  (if (tex-file-exists? "fut10.mf")
	      (-> "Runic"
		  ("Default" (make-with "font" "runic"))
		  ("Futhark" (make-with "font" "runic*"))
		  ("Futhork" (make-with "font" "runic**"))))
	  ;; ("south arabian" (make-with "font" "southarabian"))
	  ;; ("syriac" (make-with "font" "syriac"))
	  (if (tex-file-exists? "izhitsa.mf")
	      ("Old Slavonic" (make-with "font" "old-slavonic")))
	  (if (tex-file-exists? "ugaritic.mf")
	      ("Ugaritic" (make-with "font" "ugaritic"))))
      (-> "Phantasy"
	  (if (tex-file-exists? "cherokee.mf")
	      ("Cherokee" (make-with "font" "cherokee")))
	  (if (tex-file-exists? "shavian.mf")
	      ("Shavian" (make-with "font" "shavian")))
	  (if (tex-file-exists? "tengwar.mf")
	      ("Tengwar" (make-with "font" "tengwar"))))
      (-> "Miscellaneous"
	  (if (tex-file-exists? "dancers.mf")
	      ("Dancers" (make-with "font" "dancers")))
	  (if (tex-file-exists? "bbding10.mf")
	      ("Dingbat" (make-with "font" "bbding")))
	  (if (tex-file-exists? "go10.mf")
	      ("Go" (make-with "font" "go")))
	  (if (tex-file-exists? "iching.mf")
	      ("Iching" (make-with "font" "iching")))
	  (if (tex-file-exists? "karta15.mf")
	      ("Karta" (make-with "font" "karta")))
	  (if (tex-file-exists? "klinz.mf")
	      ("Klinz" (make-with "font" "klinz")))
	  (if (tex-file-exists? "magic.mf")
	      ("Magic" (make-with "font" "magic")))
	  (if (tex-file-exists? "cmph10.mf")
	      ("Phonetic" (make-with "font" "phonetic")))
	  (if (tex-file-exists? "tsipa10.mf")
	      ("Tsipa" (make-with "font" "tsipa")))
	  (if (tex-file-exists? "wsuipa10.mf")
	      ("Wsuipa" (make-with "font" "wsuipa"))))
      (-> "X-windows"
	  ("Times" (make-with "font" "x-times"))
	  ("Courier" (make-with "font" "x-courier"))
	  ("Helvetica" (make-with "font" "x-helvetica"))
	  ("Utopia" (make-with "font" "x-utopia"))
	  ("Lucida" (make-with "font" "x-lucida"))))
  (-> "Variant"
      ("Roman" (make-with "font family" "rm"))
      ("Typewriter" (make-with "font family" "tt"))
      ("Sans serif" (make-with "font family" "ss")))
  (-> "Series"
      ("Light" (make-with "font series" "light"))
      ("Medium" (make-with "font series" "medium"))
      ("Bold" (make-with "font series" "bold")))
  (-> "Shape"
      ("Right" (make-with "font shape" "right"))
      ("Slanted" (make-with "font shape" "slanted"))
      ("Italic" (make-with "font shape" "italic"))
      ("Left slanted" (make-with "font shape" "left-slanted"))
      ---
      ("Small caps" (make-with "font shape" "small-caps"))
      ("Proportional" (make-with "font shape" "proportional"))
      ("Condensed" (make-with "font shape" "condensed"))
      ("Flat" (make-with "font shape" "flat"))
      ("Long" (make-with "font shape" "long")))
  (-> "Size" (link font-size-menu)))

(menu-bind font-size-menu
  ("Tiny" (make-with "font size" "0.59"))
  ("Very small" (make-with "font size" "0.71"))
  ("Small" (make-with "font size" "0.84"))
  ("Normal" (make-with "font size" "1"))
  ("Large" (make-with "font size" "1.19"))
  ("Very large" (make-with "font size" "1.41"))
  ("Huge" (make-with "font size" "1.68"))
  ("Really huge" (make-with "font size" "2")))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; The Font submenu in math mode
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(menu-bind math-font-menu
  (-> "Name"
      ("Roman" (make-with "math font" "roman"))
      (if (tex-file-exists? "ccr10.mf")
	  ("Concrete" (make-with "math font" "concrete")))
      (if (tex-file-exists? "eurm10.mf")
	  ("New Roman" "E-C-E" (make-with "math font" "ENR")))
      ---
      (if (tex-file-exists? "rpsyr.tfm")
	  ("Adobe" (make-with "math font" "adobe")))
      (if (tex-file-exists? "cdr10.mf")
	  ("Duerer" (make-with "math font" "Duerer")))
      (if (tex-file-exists? "eufm10.mf")
	  ("Euler" (make-with "math font" "Euler")))
      (-> "Calligraphic"
	  ("Default" (make-with "math font" "cal"))
	  (if (tex-file-exists? "euxm10.mf")
	      ("Euler" (make-with "math font" "cal**")))
	  (if (tex-file-exists? "rsfs10.mf")
	      ("Ralph Smith's" (make-with "math font" "cal*"))))
      (-> "Blackboard bold"
	  ("Default" (make-with "math font" "Bbb*"))
	  (if (tex-file-exists? "msbm10.mf")
	      ("A.M.S." (make-with "math font" "Bbb")))
	  (if (tex-file-exists? "bbold10.mf")
	      ("Blackboard bold" (make-with "math font" "Bbb**")))
	  (if (tex-file-exists? "ocmr10.mf")
	      ("Outlined roman" (make-with "math font" "Bbb***")))
	  (if (tex-file-exists? "dsrom10.mf")
	      ("Double stroke" (make-with "math font" "Bbb****")))))
  (if (real-math-font? (get-env "math font"))
      (-> "Variant"
	  ("Roman" (make-with "math font family" "mr"))
	  ("Typewriter" (make-with "math font family" "mt"))
	  ("Sans serif" (make-with "math font family" "ms"))
	  ---
	  (-> "Text font"
	      ("Roman" (make-with "math font family" "rm"))
	      ("Typewriter" (make-with "math font family" "tt"))
	      ("Sans serif" (make-with "math font family" "ss"))
	      ("Bold" (make-with "math font family" "bf"))
	      ("Right" (make-with "math font family" "up"))
	      ("Slanted" (make-with "math font family" "sl"))
	      ("Italic" (make-with "math font family" "it"))))
      (if (real-math-family? (get-env "math font family"))
	  (-> "Series"
	      ("Light" (make-with "math font series" "light"))
	      ("Medium" (make-with "math font series" "medium"))
	      ("Bold" (make-with "math font series" "bold")))))
  (if (not (real-math-font? (get-env "math font")))
      (-> "Variant"
	  ("Roman" (make-with "math font family" "mr"))
	  ("Typewriter" (make-with "math font family" "mt"))
	  ("Sans serif" (make-with "math font family" "ms")))
      (-> "Series"
	  ("Medium" (make-with "math font series" "medium"))
	  ("Bold" (make-with "math font series" "bold")))
      (-> "Shape"
	  ("Default" (make-with "math font shape" "normal"))
	  ("Right" (make-with "math font shape" "right"))
	  ("Slanted" (make-with "math font shape" "slanted"))
	  ("Italic" (make-with "math font shape" "italic"))))
  (-> "Size" (link font-size-menu)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; The Font submenu in prog mode
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(menu-bind prog-font-menu
  (-> "Name"
      ("roman" (make-with "prog font" "roman"))
      (if (tex-file-exists? "ccr10.mf")
	  ("concrete" (make-with "prog font" "concrete")))
      (if (tex-file-exists? "pnr10.mf")
	  ("pandora" (make-with "prog font" "pandora"))))
  (-> "Variant"
      ("Roman" (make-with "prog font family" "rm"))
      ("Typewriter" (make-with "prog font family" "tt"))
      ("Sans serif" (make-with "prog font family" "ss")))
  (-> "Series"
      ("Medium" (make-with "prog font series" "medium"))
      ("Bold" (make-with "prog font series" "bold")))
  (-> "Shape"
      ("Default" (make-with "prog font shape" "normal"))
      ("Right" (make-with "prog font shape" "right"))
      ("Slanted" (make-with "prog font shape" "slanted"))
      ("Italic" (make-with "prog font shape" "italic")))
  (-> "Size" (link font-size-menu)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; The Color and Language submenus
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(menu-bind color-menu
  ("Black" (make-with "color" "black"))
  ("White" (make-with "color" "white"))
  ("Grey" (make-with "color" "grey"))
  ("Red" (make-with "color" "red"))
  ("Blue" (make-with "color" "blue"))
  ("Yellow" (make-with "color" "yellow"))
  ("Green" (make-with "color" "green"))
  ("Orange" (make-with "color" "orange"))
  ("Magenta" (make-with "color" "magenta"))
  ("Brown" (make-with "color" "brown"))
  ("Pink" (make-with "color" "pink")))

(menu-bind language-menu
  ("British" (make-with "language" "british"))
  ("Czech" (make-with "language" "czech"))
  ("Dutch" (make-with "language" "dutch"))
  ("English" (make-with "language" "english"))
  ("Finnish" (make-with "language" "finnish"))
  ("French" (make-with "language" "french"))
  ("German" (make-with "language" "german"))
  ("Hungarian" (make-with "language" "hungarian"))
  ("Italian" (make-with "language" "italian"))
  ("Polish" (make-with "language" "polish"))
  ("Portuguese" (make-with "language" "portuguese"))
  ("Romanian" (make-with "language" "romanian"))
  ("Russian"
   (begin
     (make-with "language" "russian")
     (make-with "font" "cyrillic")))
  ("Spanish" (make-with "language" "spanish"))
  ("Swedish" (make-with "language" "swedish"))
  ("Ukrainian"
   (begin
     (make-with "language" "ukrainian")
     (make-with "font" "cyrillic"))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Extra formatting submenus for math mode
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(menu-bind math-format-menu
  (-> "Index level"
      ("Normal" (make-with "index level" "0"))
      ("Script size" (make-with "index level" "1"))
      ("Script script size" (make-with "index level" "2")))
  (-> "Formula style"
      ("On" (make-with "formula style" "true"))
      ("Off" (make-with "formula style" "false")))
  (-> "Condensed"
      ("On" (make-with "math condensed" "true"))
      ("Off" (make-with "math condensed" "false"))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Formatting of paragraphs
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(menu-bind paragraph-menu
  (-> "Alignment"
      ("Justified" (make-line-with "paragraph mode" "justify"))
      ("Left ragged" (make-line-with "paragraph mode" "left"))
      ("Centered" (make-line-with "paragraph mode" "center"))
      ("Right ragged" (make-line-with "paragraph mode" "right")))
  (-> "Margins"
      ("Left margin" ... (interactive '("Left margin:") 'set-left-margin))
      ("Right margin" ... (interactive '("Right margin:") 'set-right-margin))
      ("First indentation" ...
       (interactive '("First indentation:") 'set-first-indent)))
  (-> "Spacing"
      ("Interline separation" ...
       (interactive '("Separation between lines:") 'set-interline))
      ("Interline space" ...
       (interactive '("Space between lines:") 'set-interline-spc))
      ("Interparagraph space" ...
       (interactive '("Space between paragraphs:") 'set-interpar-spc)))
  (-> "Hyphenation"
      ("Normal" (make-line-with "paragraph hyphenation" "normal"))
      ("Professional"
       (make-line-with "paragraph hyphenation" "professional")))
  (-> "Number of columns"
      ("1" (make-line-with "nr columns" "1"))
      ("2" (make-line-with "nr columns" "2"))
      ("3" (make-line-with "nr columns" "3"))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; The main Format menu
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(menu-bind format-menu
  (group "Font")
  (if (test-env? "mode" "text") (link text-font-menu))
  (if (test-env? "mode" "math") (link math-font-menu))
  (if (test-env? "mode" "prog") (link prog-font-menu))
  ---
  (group "Content")
  (-> "Color" (link color-menu))
  (-> "Language" (link language-menu))
  (if (test-env? "mode" "math")
      ---
      (link math-format-menu))
  ---
  (group "Paragraph")
  (link paragraph-menu))
