
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; MODULE      : setup-texmacs.scm
;; DESCRIPTION : Setup of TeXmacs at first run
;; COPYRIGHT   : (C) 1999  Joris van der Hoeven
;;
;; This software falls under the GNU general public license and comes WITHOUT
;; ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for details.
;; If you don't have this file, write to the Free Software Foundation, Inc.,
;; 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(define setup-commands '((noop)))

(define-macro (setup-append-if test . cmds)
  `(if ,test (set! setup-commands
		   (append (reverse ,(list 'quasiquote cmds))
			   setup-commands))))

(for-each (lambda (name) (load name))
	  (map symbol->string (plugin-setup-files)))

(save-expr "$TEXMACS_HOME_PATH/system/setup.scm"
	   (cons 'begin (reverse setup-commands)))
