
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; MODULE      : checkmarks.scm
;; DESCRIPTION : setting checkmarks (should disappear)
;; COPYRIGHT   : (C) 2002  Joris van der Hoeven, David Allouche
;;
;; This software falls under the GNU general public license and comes WITHOUT
;; ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for details.
;; If you don't have this file, write to the Free Software Foundation, Inc.,
;; 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Automatic check marks
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(set-check-mark! init-default "*" test-default?)
(set-check-mark! make-with "o" test-env?)
(set-check-mark! init-env "*" test-init?)

(define (test-shrinking-factor? n) (= (get-shrinking-factor) n))
(set-check-mark! toggle-full-screen-mode "v" full-screen?)
(set-check-mark! toggle-visible-header "v" visible-header?)
(set-check-mark! toggle-visible-icon-bar "v" visible-icon-bar?)
(set-check-mark! toggle-visible-footer "v" visible-footer?)
(set-check-mark! set-shrinking-factor "*" test-shrinking-factor?)

(define (test-preamble?) (string=? (get-env "preamble") "true"))
(define (test-page-medium? s) (string=? (get-env "page medium") s))
(define (test-page-type? s) (string=? (get-env "page type") s))
(define (test-page-orientation? s) (string=? (get-env "page orientation") s))
(define (visible-header-and-footer?)
  (== "true" (get-env "show header and footer")))
(define (as-on-paper?)
  (and (visible-header-and-footer?)
       (length-zero? (get-env "reduction page left margin"))
       (length-zero? (get-env "reduction page right margin"))
       (length-zero? (get-env "reduction page top margin"))
       (length-zero? (get-env "reduction page bottom margin"))))
(set-check-mark! toggle-preamble "v" test-preamble?)
(set-check-mark! set-page-medium "*" test-page-medium?)
(set-check-mark! set-page-type "*" test-page-type?)
(set-check-mark! set-page-orientation "*" test-page-orientation?)
(set-check-mark! toggle-visible-header-and-footer
		 "v" visible-header-and-footer?)
(set-check-mark! init-as-on-paper "o" as-on-paper?)

(define (selection-test-import? s) (string=? s (selection-get-import)))
(define (selection-test-export? s) (string=? s (selection-get-export)))
(define (session-test-math-input? b?) (if (session-math-input?) b? (not b?)))
(set-check-mark! selection-set-import "*" selection-test-import?)
(set-check-mark! selection-set-export "*" selection-test-export?)
(set-check-mark! session-use-math-input "*" session-test-math-input?)
(set-check-mark! toggle-insertion-position "v" test-insertion-position?)
(define (toggle-insertion-position-not s) (toggle-insertion-position s))
(define (test-insertion-position-not? s) (not (test-insertion-position? s)))
(set-check-mark! toggle-insertion-position-not
		 "v" test-insertion-position-not?)

(define (test-cell-mode? s) (string=? (get-cell-mode) s))
(set-check-mark! set-cell-mode "*" test-cell-mode?)
