
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; MODULE      : tm-mode.el
;; DESCRIPTION : for editing TeXmacs scheme files with Emacs
;; COPYRIGHT   : (C) 2002  Joris van der Hoeven
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; This software falls under the GNU general public license and comes WITHOUT
;; ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for details.
;; If you don't have this file, write to the Free Software Foundation, Inc.,
;; 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(font-lock-add-keywords 'scheme-mode
 '(("\\<\\(define-macro\\|define-table\\|case-lambda\\|with\\|receive\\|map-in-order\\|drd-group\\|drd-table\\|drd-dispatcher\\|tm-define\\|tm-command\\|tm-macro\\|define-grammar\\|drd-rule\\|drd-rules\\|assume\\|menu-bind\\|menu-extend\\|menu-dynamic\\|kbd-map\\|kbd-wildcards\\|setup-append-if\\|when\\|link\\|promise\\|plugin-configure\\|plugin-input-converters\\)\\>" . font-lock-keyword-face)
   ("(\\(define-macro\\|define-table\\|tm-define\\|tm-command\\|tm-macro\\|menu-bind\\|menu-extend\\|plugin-configure\\|plugin-input-converters\\)\\>[ 	]*\\((?\\)\\(\\sw+\\)\\>" . (3 font-lock-function-name-face))
   ("\\<\\(\\sw+%\\)\\>" . font-lock-type-face)))

(put 'with 'scheme-indent-function 2)
(put 'receive 'scheme-indent-function 2)
(put 'setup-append-if 'scheme-indent-function 1)
(put 'tm-define 'scheme-indent-function 1)
(put 'tm-command 'scheme-indent-function 1)
(put 'tm-macro 'scheme-indent-function 1)
(put 'drd-group 'scheme-indent-function 1)
(put 'drd-table 'scheme-indent-function 1)
(put 'drd-dispatcher 'scheme-indent-function 1)
(put 'menu-bind 'scheme-indent-function 1)
(put 'menu-extend 'scheme-indent-function 1)
(put 'plugin-configure 'scheme-indent-function 1)
(put 'plugin-input-converters 'scheme-indent-function 1)
(put 'menu-dynamic 'scheme-indent-function 0)
(put 'case-lambda 'scheme-indent-function 0)
(put 'kbd-map 'scheme-indent-function 0)
(put 'kbd-wildcards 'scheme-indent-function 0)
(put 'define-grammar 'scheme-indent-function 0)
(put 'drd-rule 'scheme-indent-function 0)
(put 'drd-rules 'scheme-indent-function 0)
(put 'assume 'scheme-indent-function 0)
