/*
    statusbaricon.cpp  -  Kopete StatusBar Dock Icon

    Copyright (c) 2001-2002 by Duncan Mac-Vicar Prett   <duncan@kde.org>

    Kopete    (c) 2002 by the Kopete developers  <kopete-devel@kde.org>

    *************************************************************************
    *                                                                       *
    * This program is free software; you can redistribute it and/or modify  *
    * it under the terms of the GNU General Public License as published by  *
    * the Free Software Foundation; either version 2 of the License, or     *
    * (at your option) any later version.                                   *
    *                                                                       *
    *************************************************************************
*/

#include "statusbaricon.h"

#include <qpixmap.h>

//#include <kdebug.h>

StatusBarIcon::StatusBarIcon( KopeteProtocol *proto, QWidget *parent,
	const char *name )
: QLabel( parent, name )
{
//	kdDebug(14000) << "[StatusBarIcon] Setting Initial Protocol Icon" << endl;
	//setMask(initialPixmap->mask());
	setPixmap( QPixmap() );

	setFixedSize ( 16, 16 );
	show();

	m_proto = proto;
}

StatusBarIcon::~StatusBarIcon()
{
}

void StatusBarIcon::mousePressEvent( QMouseEvent *me )
{
	if( me->button() == QEvent::RightButton )
	{
		emit rightClicked( m_proto, QPoint( me->globalX(), me->globalY() ) );
	}
}

#include "statusbaricon.moc"

// vim: set noet ts=4 sts=4 sw=4:

