/*
    messagelog.h  -  Kopete Logger

    Copyright (c) 2001-2002 by Ryan Cumming. <bodnar42@phalynx.dhs.org>

    Kopete    (c) 2002 by the Kopete developers  <kopete-devel@kde.org>

    *************************************************************************
    *                                                                       *
    * This program is free software; you can redistribute it and/or modify  *
    * it under the terms of the GNU General Public License as published by  *
    * the Free Software Foundation; either version 2 of the License, or     *
    * (at your option) any later version.                                   *
    *                                                                       *
    *************************************************************************
*/

#ifndef _MESSAGELOG_H
#define _MESSAGELOG_H

#include <qobject.h>
#include <qfile.h>

#include "kopetemessage.h"


class QString;
class QDateTime;

/**
 * @author Ryan Cumming. <bodnar42@phalynx.dhs.org>
 *
 */

class KopeteMessageLog : public QObject
{
  Q_OBJECT
  public:
	KopeteMessageLog(QString filename, QObject *parent = 0, const char *name = 0);

	// Is the log file open and writable?
	virtual bool ok();
	// Log a message to this log file
	virtual bool append(const KopeteMessage &);

  protected:
	QFile mLogFile;
};

#endif
/*
 * Local variables:
 * c-indentation-style: k&r
 * c-basic-offset: 8
 * indent-tabs-mode: t
 * End:
 */
// vim: set noet ts=4 sts=4 sw=4:

