/*
    kopeteuserpreferences.cpp  -  Kopete User Preferences

    Copyright (c) 2002      by Chris TenHarmsel       <ctenha56@calvin.edu>

    Kopete    (c) 2002-2003 by the Kopete developers  <kopete-devel@kde.org>

    *************************************************************************
    *                                                                       *
    * This program is free software; you can redistribute it and/or modify  *
    * it under the terms of the GNU General Public License as published by  *
    * the Free Software Foundation; either version 2 of the License, or     *
    * (at your option) any later version.                                   *
    *                                                                       *
    *************************************************************************
*/

#include "kopeteuserpreferences.h"
#include "kopeteuserpreferences.moc"              
#include "kopeteaway.h"
#include "ui/kopeteawayconfigui.h" // Away message configuration UI

#include <qframe.h>
#include <qlayout.h>
#include <ktabctl.h>
#include <klocale.h>

KopeteUserPreferencesConfig::KopeteUserPreferencesConfig( QWidget *parent )
: ConfigModule( i18n( "Away Messages" ), i18n( "Here you can edit preset away messages" ), QString::fromLatin1( "edit" ), parent )
{
	QVBoxLayout *topLayout = new QVBoxLayout( this );

	mAwayConfigUI = new KopeteAwayConfigUI(this);
	topLayout->add(mAwayConfigUI);
}

void KopeteUserPreferencesConfig::save()
{
	/* Tells KopeteAway to save it's messages */
	KopeteAway::getInstance()->save();

}

void KopeteUserPreferencesConfig::reopen()
{
	/* Updates the info in the AwayConfig UI from the KopeteAway object */
	mAwayConfigUI->updateView();

}
