/*
    kopetehistorydialog.cpp - Kopete History Dialog
    
    Copyright (c) 2002 by
    Richard Stellingwerff <remenic@linuxfromscratch.org>

    Kopete    (c) 2002 by the Kopete developers  <kopete-devel@kde.org>

    *************************************************************************
    *                                                                       *
    * This program is free software; you can redistribute it and/or modify  *
    * it under the terms of the GNU General Public License as published by  *
    * the Free Software Foundation; either version 2 of the License, or     *
    * (at your option) any later version.                                   *
    *                                                                       *
    *************************************************************************
*/

#include <kdebug.h>
#include <klocale.h>

#include <qapplication.h>
#include <qlayout.h>
#include <kdialogbase.h>

#include "kopetehistorydialog.h"
#include "kopetehistorywidget.h"

KopeteHistoryDialog::KopeteHistoryDialog( KopeteContact *mContact, bool showclose, int count, QWidget* parent, const char* name )
	: KDialogBase( KDialogBase::Plain, i18n("History for %1").arg( mContact->displayName() ), KDialogBase::Close, KDialogBase::Close , parent, name, false)
{
	kdDebug(14010) << k_funcinfo << "called." << endl;
	setWFlags(Qt::WDestructiveClose);	// send SIGNAL(closing()) on quit

	showButton(KDialogBase::Close, showclose); // hide Close button if showClose is false

	QHBoxLayout *layout = new QHBoxLayout( plainPage() );
	mHistoryWidget = new KopeteHistoryWidget( mContact, count, plainPage(), "mHistoryWidget" );
	layout->addWidget( mHistoryWidget );
	
	mHistoryWidget->setMinimumHeight(400);

	// I won't live without my widget!
	connect(mHistoryWidget, SIGNAL(closing()), this, SLOT(close()));
	
	// show the dialog before people get impatient
	show();

	// kay, draw the widget
	mHistoryWidget->show();
	qApp->processEvents();

	// now load the log, count the amount of messages, and display a few messages
	mHistoryWidget->init();
}

KopeteHistoryDialog::KopeteHistoryDialog( KopeteMetaContact *mContact, bool showClose, int count, QWidget* parent, const char* name )
	: KDialogBase( Plain, i18n("History for %1").arg( mContact->displayName() ), Close, Close, parent, name, false)
{
	kdDebug(14010) << k_funcinfo << "called." << endl;
	setWFlags(Qt::WDestructiveClose);	// send SIGNAL(closing()) on quit

	showButton(KDialogBase::Close, showClose); // hide Close button if showClose is false

	QHBoxLayout *layout = new QHBoxLayout( plainPage() );
	mHistoryWidget = new KopeteHistoryWidget( mContact, count, plainPage(), "mHistoryWidget" );
	layout->addWidget( mHistoryWidget );

	mHistoryWidget->setMinimumHeight(400);

	// I won't live without my widget!
	connect(mHistoryWidget, SIGNAL(closing()), this, SLOT(close()));

	// show the dialog before people get impatient
	show();

	// kay, draw the widget
	mHistoryWidget->show();
	qApp->processEvents();

	// now load the log, count the amount of messages, and display a few messages
	mHistoryWidget->init();
}

KopeteHistoryDialog::~KopeteHistoryDialog()
{
	kdDebug(14010) << k_funcinfo << "called." << endl;
}

#include "kopetehistorydialog.moc"

/*
 * Local variables:
 * c-indentation-style: k&r
 * c-basic-offset: 8
 * indent-tabs-mode: t
 * End:
 */
// vim: set noet ts=4 sts=4 sw=4:

