/*
    kopetehistorydialog.h - Kopete History Dialog

    Copyright (c) 2002 by
    Richard Stellingwerff <remenic@linuxfromscratch.org>
   
    Kopete    (c) 2002 by the Kopete developers  <kopete-devel@kde.org>

    *************************************************************************
    *                                                                       *
    * This program is free software; you can redistribute it and/or modify  *
    * it under the terms of the GNU General Public License as published by  *
    * the Free Software Foundation; either version 2 of the License, or     *
    * (at your option) any later version.                                   *
    *                                                                       *
    *************************************************************************
*/

#ifndef _HISTORYDIALOG_H
#define _HISTORYDIALOG_H
#include "kopetecontact.h"
#include "kopetemetacontact.h"
#include <kdialogbase.h>
#include <qdialog.h>

class KDialogBase;
class KopeteHistoryWidget;

/**
 * @author Richard Stellingwerff <remenic@linuxfromscratch.org>
 *
 */

class KopeteHistoryDialog : public KDialogBase
{
	Q_OBJECT
public:
	KopeteHistoryDialog( KopeteContact *mContact, const bool showclose = true, int count = 50, QWidget* parent=0, const char* name="KopeteHistoryDialog");
	KopeteHistoryDialog( KopeteMetaContact *mContact, const bool showclose = true, int count = 50, QWidget* parent=0, const char* name="KopeteHistoryDialog");
	~KopeteHistoryDialog();

private:
	KopeteHistoryWidget *mHistoryWidget;

signals:
	void closing();
};

#endif


/*
 * Local variables:
 * c-indentation-style: k&r
 * c-basic-offset: 8
 * indent-tabs-mode: t
 * End:
 */
// vim: set noet ts=4 sts=4 sw=4:

