/***************************************************************************
                          autoawayplugin.h  -  description
                             -------------------
    begin                : mi abr 10 2002
    copyright            : (C) 2002 by Duncan Mac-Vicar Prett
    email                : duncan@kde.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef AUTOAWAYPLUGIN_H
#define AUTOAWAYPLUGIN_H

#include "kopeteplugin.h"

class AutoAwayPreferences;
class XAutoLock;

/**
 * @author Duncan Mac-Vicar Prett
 */
class AutoAwayPlugin : public KopetePlugin
{
	Q_OBJECT

public:
	AutoAwayPlugin( QObject *parent, const char *name, const QStringList &args );
	~AutoAwayPlugin();
	virtual void init();
	virtual bool unload();

public slots:
	void slotTimeout();
	void slotActivity();
	void slotSettingsChanged();
private:
	XAutoLock *mWatcher;
	AutoAwayPreferences *mPrefs;
	bool mActive;
};

#endif

// vim: set noet ts=4 sts=4 sw=4:

