#include "autoawaypreferences.h"
#include "autoawaypreferences.moc"

#include <qlayout.h>
#include <kconfig.h>
#include <kglobal.h>
#include <klocale.h>
#include <klineedit.h>
#include <kdebug.h>
#include <qlabel.h>
#include <qgroupbox.h>


#include <knuminput.h>

AutoAwayPreferences::AutoAwayPreferences(const QString &pixmap,QObject *parent)
							: ConfigModule(i18n("Auto-Away"),i18n("Auto-Away Plugin"),pixmap,parent)
{
	( new QVBoxLayout( this ) )->setAutoAdd( true );
	preferencesDialog = new autoawayPrefsUI(this);
	
	KGlobal::config()->setGroup("AutoAway Plugin");
	preferencesDialog->mAwayTimeout->setValue(KGlobal::config()->readNumEntry("Timeout", 10));
	preferencesDialog->mGoAvailable->setChecked(KGlobal::config()->readBoolEntry("GoAvailable", false));
}

AutoAwayPreferences::~AutoAwayPreferences()
{
}

void AutoAwayPreferences::save()
{
	KConfig *config=KGlobal::config();
	config->setGroup("AutoAway Plugin");
	config->writeEntry("Timeout", preferencesDialog->mAwayTimeout->value());
	config->writeEntry("GoAvailable", preferencesDialog->mGoAvailable->isChecked());
	config->sync();
	emit saved();

}

/*
 * Local variables:
 * c-indentation-style: k&r
 * c-basic-offset: 8
 * indent-tabs-mode: t
 * End:
 */
// vim: set noet ts=4 sts=4 sw=4:

