/*
    importer.h

    Kopete Importer plugin

    Copyright (c) 2002 by James Grant   <topace@lightbox.org>

    Kopete    (c) 2002 by the Kopete developers  <kopete-devel@kde.org>

    *************************************************************************
    *                                                                       *
    * This program is free software; you can redistribute it and/or modify  *
    * it under the terms of the GNU General Public License as published by  *
    * the Free Software Foundation; either version 2 of the License, or     *
    * (at your option) any later version.                                   *
    *                                                                       *
    *************************************************************************
*/

#ifndef IMPORTER_H
#define IMPORTER_H

#include <qmap.h>
#include <qpair.h>
#include <qcombobox.h>

#include <qwidget.h>
#include <klineedit.h>
#include "configmodule.h"

class QString;
class ImporterUI;

/**
  * @author James Grant   <topace@lightbox.org>
  *
  * Importer Plugin UI
  *
  */

class Importer : public ConfigModule
{
Q_OBJECT
public:
	Importer(const QString &pixmap,QObject *parent=0);
	~Importer();

public slots:
	void slotChooseFile();
	void slotDoImport();
	void slotProgramChanged(int);

private:
	ImporterUI *ImporterDialog;	
};

#endif

/*
 * Local variables:
 * c-indentation-style: k&r
 * c-basic-offset: 8
 * indent-tabs-mode: t
 * End:
 */
// vim: set noet ts=4 sts=4 sw=4:

