/*
    importerplugin.cpp

    Kopete Importer plugin

    Copyright (c) 2001-2002 by James Grant   <topace@lightbox.org>

    Kopete    (c) 2002 by the Kopete developers  <kopete-devel@kde.org>

    *************************************************************************
    *                                                                       *
    * This program is free software; you can redistribute it and/or modify  *
    * it under the terms of the GNU General Public License as published by  *
    * the Free Software Foundation; either version 2 of the License, or     *
    * (at your option) any later version.                                   *
    *                                                                       *
    *************************************************************************
*/

#include "importerplugin.h"
#include "importerplugin.moc"

#include <qcolor.h>
#include <qcstring.h>
#include <qstring.h>
#include <qregexp.h>
#include <qmap.h>

#include <kdebug.h>
#include <kaction.h>
#include <klocale.h>
#include <kgenericfactory.h>
#include <kstandarddirs.h>

#include "kopetecontact.h"
#include "kopetemessage.h"
#include "kopetemetacontact.h"
#include "importer.h"

K_EXPORT_COMPONENT_FACTORY( kopete_importer, KGenericFactory<ImporterPlugin> );

ImporterPlugin::ImporterPlugin( QObject *parent, const char *name,
	const QStringList &/*args*/ )
: KopetePlugin( parent, name )
{
	if ( pluginStatic_ )
		kdDebug(14304)<<"####"<<"Importer Plugin already initialized"<<endl;
	else
		pluginStatic_ = this;

	m_programs.insert("_empty",i18n("Choose a Program"));
	m_programs.insert("licq",i18n("LICQ (ICQ)"));
	m_programs.insert("trillian",i18n("Trillian (ICQ,MSN)"));
	m_programs.insert("proteus",i18n("Proteus (ICQ,MSN)"));
	m_programs.insert("gaim_icq",i18n("Gaim (ICQ)"));
	m_programs.insert("gaim_msn",i18n("Gaim (MSN)"));

	QMap<QString,QString>::ConstIterator i;
	m_pc=0;
	for ( i = m_programs.begin(); i != m_programs.end() ; ++i )
	{
			m_programsIntKeyMap[m_pc] = i.key();
			m_programsKeyIntMap[i.key()] = m_pc;
			m_pc++;
	}


	m_importer=new Importer("fileimport",this);

}

ImporterPlugin::~ImporterPlugin()
{
	pluginStatic_ = 0L;
}

ImporterPlugin* ImporterPlugin::plugin()
{
	return pluginStatic_ ;
}

ImporterPlugin* ImporterPlugin::pluginStatic_ = 0L;

/*
 * Local variables:
 * c-indentation-style: k&r
 * c-basic-offset: 8
 * indent-tabs-mode: t
 * End:
 */
// vim: set noet ts=4 sts=4 sw=4:

