/*
    importerplugin.h

    Kopete Importer plugin

    Copyright (c) 2002 by James Grant   <topace@lightbox.org>

    Kopete    (c) 2002 by the Kopete developers  <kopete-devel@kde.org>

    *************************************************************************
    *                                                                       *
    * This program is free software; you can redistribute it and/or modify  *
    * it under the terms of the GNU General Public License as published by  *
    * the Free Software Foundation; either version 2 of the License, or     *
    * (at your option) any later version.                                   *
    *                                                                       *
    *************************************************************************
*/

#ifndef IMPORTERPLUGIN_H
#define IMPORTERPLUGIN_H

#include <qobject.h>
#include <qmap.h>
#include <qcstring.h>
#include <qintdict.h>
#include <qstring.h>

#include "kopetemessage.h"
#include "kopeteplugin.h"

class QStringList;
class QString;
class KListAction;

class KopeteMessage;
class KopeteMetaContact;

class Importer;

class ImporterPlugin : public KopetePlugin
{
	Q_OBJECT

public:
	static  ImporterPlugin  *plugin();

	ImporterPlugin( QObject *parent, const char *name, const QStringList &args );
	~ImporterPlugin();

	/***************************************************************************
	 *   Plugin's API (used by preferences)                                    *
	 ***************************************************************************/
	
	const QMap<QString,QString>& programsMap()
	{ return m_programs; };
	
	const int programsIndex ( const QString &key )
	{ return m_programsKeyIntMap[key]; };

	const QString& programsKey ( const int index )
	{ return m_programsIntKeyMap[index]; };


public slots:

protected:

private:
	//programs map
	QMap< QString, QString> m_programs;

	//int to programs key and programs to int key
        QMap<int, QString> m_programsIntKeyMap;
        QMap<QString, int> m_programsKeyIntMap;

	//programs counter
	int m_pc;

	KopeteMetaContact *m_currentMetaContact;
	Importer *m_importer;
	static ImporterPlugin* pluginStatic_;

};

#endif

/*
 * Local variables:
 * c-indentation-style: k&r
 * c-basic-offset: 8
 * indent-tabs-mode: t
 * End:
 */
// vim: set noet ts=4 sts=4 sw=4:

