/***************************************************************************
                          icqchangestatus.cpp  -  description
                             -------------------
    begin                : Wed Jan 26 2002
    copyright            : (C) 2002 by nbetcher
    email                : nbetcher@usinternet.com
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "icqchangestatus.h"
#include "icqchangestatus.moc"

#include <kdebug.h>

#include "icqprotocol.h"
#include "client.h"

ICQChangeStatus::ICQChangeStatus(ICQProtocol *protocol, QWidget *parent, const char *name)
	: KopeteAwayDialog(parent, name)
{
	// Hold on to the pointer to our protocol
	// We don't delete this
	mProtocol = protocol;
}

void ICQChangeStatus::setAway(QString awayType)
{
	kdDebug(14110) << k_funcinfo << "called, awayType=" << awayType << endl;

	if(awayType == "ICQ_STATUS_AWAY")
	{
		// Set us away
		mProtocol->engine()->owner->AutoResponseAway = getSelectedAwayMessage().local8Bit();
		mProtocol->engine()->setStatus(ICQ_STATUS_AWAY);
	}
	else if(awayType == "ICQ_STATUS_NA")
	{
		// Set us NA
		mProtocol->engine()->owner->AutoResponseNA = getSelectedAwayMessage().local8Bit();
		mProtocol->engine()->setStatus(ICQ_STATUS_NA);
	}
	else if(awayType == "ICQ_STATUS_DND")
	{
		// Set us DND
		mProtocol->engine()->owner->AutoResponseDND = getSelectedAwayMessage().local8Bit();
		mProtocol->engine()->setStatus(ICQ_STATUS_DND);
	}
	else if(awayType == "ICQ_STATUS_OCCUPIED")
	{
		// Set us Occupied
		mProtocol->engine()->owner->AutoResponseOccupied = getSelectedAwayMessage().local8Bit();
		mProtocol->engine()->setStatus(ICQ_STATUS_OCCUPIED);
	}
	else
	{
		kdDebug(14110) << k_funcinfo << "unknown away type, defaulting to AWAY!" << endl;
		// Not sure what to do here, so set Away by default
		mProtocol->engine()->owner->AutoResponseAway = getSelectedAwayMessage().local8Bit();
		mProtocol->engine()->setStatus(ICQ_STATUS_AWAY);
	}
}

/*
 * Local variables:
 * mode: c++
 * c-indentation-style: k&r
 * c-basic-offset: 4
 * indent-tabs-mode: t
 * End:
 */
