 /*
    icqchangestatus.h  -  ICQ Protocol Plugin

    Copyright (c) 2002 by Nick Betcher <nbetcher@kde.org>
    
    Kopete    (c) 2002 by the Kopete developers  <kopete-devel@kde.org>

    *************************************************************************
    *                                                                       *
    * This program is free software; you can redistribute it and/or modify  *
    * it under the terms of the GNU General Public License as published by  *
    * the Free Software Foundation; either version 2 of the License, or     *
    * (at your option) any later version.                                   *
    *                                                                       *
    *************************************************************************
*/

#ifndef ICQCHANGESTATUS_HI
#define ICQCHANGESTATUS_HI

#include <kopeteawaydialog.h>
#include "icqprotocol.h"

class ICQChangeStatus : public KopeteAwayDialog
{
    Q_OBJECT
public:
    ICQChangeStatus( ICQProtocol *protocol, QWidget *parent = 0L, const char *name = 0);

protected slots:
    /**
     * This method does it all.  It reads the away
     * type and sets us away using our pointer
     * to the protocol object
     */
    virtual void setAway(QString awayType);
    
private:
    /**
     * Pointer to the main ICQ protocol object
     */
    ICQProtocol *mProtocol;
};

#endif
/*
 * Local variables:
 * mode: c++
 * c-indentation-style: k&r
 * c-basic-offset: 4
 * indent-tabs-mode: t
 * End:
 */
