 /*
    icqfiletransfer.h  -  ICQ Protocol Plugin

    Copyright (c) 2002 by Nick Betcher <nbetcher@kde.org>
    
    Kopete    (c) 2002 by the Kopete developers  <kopete-devel@kde.org>

    *************************************************************************
    *                                                                       *
    * This program is free software; you can redistribute it and/or modify  *
    * it under the terms of the GNU General Public License as published by  *
    * the Free Software Foundation; either version 2 of the License, or     *
    * (at your option) any later version.                                   *
    *                                                                       *
    *************************************************************************
*/
 
#ifndef ICQFILETRANSFER_H
#define ICQFILETRANSFER_H
 
#include "qobject.h"

class ICQFile;
class KopeteTransfer;
class ICQProtocol;
class QTimer;
class ICQEvent;

class ICQFileTransfer : public QObject
{
Q_OBJECT
public:
	ICQFileTransfer(ICQFile *, KopeteTransfer *, ICQProtocol *, QObject *parent = 0, const char *name=0);
private:
	ICQFile *mFile;
	KopeteTransfer *mTransfer;
	ICQProtocol *mProtocol;
	QTimer *mTimer;
	bool tryAbort;
private slots:
	void slotUpdateProgress(void);
	void slotEvent(ICQEvent *);
	void slotCancelTransfer(void);
};

#endif
