/***************************************************************************
                          icquserreason.cpp  -  description
                             -------------------
    begin                : Sep 2 2002
    copyright            : (C) 2002 by metz
    email                : sgehn@gmx.net

    based on sim sourcecode which is (c) Vladimir Shutoff

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "icquserreason.h"
#include "icqprotocol.h"
#include "icqcontact.h"
#include "client.h"
#include <kdebug.h>
#include <klocale.h>
#include <qtextedit.h>
#include <qlayout.h>

ICQUserReason::ICQUserReason( ICQContact *c, ICQProtocol *protocol, QWidget *parent, const char* name)
	: KDialogBase( parent, name, /*modal = */false, QString::null,
		Close | User1, Close, false, i18n("&Fetch again") )
{
	mContact  = c;
	mProtocol = protocol;

	setCaption(i18n("Autoreply for %1").arg(mContact->displayName()));

	mMainWidget = new QWidget( this );
	mMainWidget->setMinimumWidth(240);
	mMainWidget->setMinimumHeight(100);

	QBoxLayout * l = new QHBoxLayout( mMainWidget );
	mTextEdit = new QTextEdit( mMainWidget, "textedit" );
	l->addWidget( mTextEdit );
	setMainWidget( mMainWidget );
	
	mTextEdit->setReadOnly( true );
	mTextEdit->setText ( mContact->mUser->AutoReply.c_str() );

	connect(c, SIGNAL(updatedInfoPartly()), this, SLOT(slotReadInfo()));
	connect(this, SIGNAL(user1Clicked()), this, SLOT(slotFetchInfo()));
	connect(this, SIGNAL(closeClicked()), this, SIGNAL(closing()));

	slotFetchInfo();
}

void ICQUserReason::slotFetchInfo()
{
	if ( mProtocol->engine()->isLogged() )
	{
		kdDebug(14110) << "[ICQUserReason] slotFetchInfo(); fetching Autoreply..." << endl;
		mMainWidget->setDisabled( true );
		enableButton(User1,false);
		mProtocol->engine()->addResponseRequest(mContact->uin(), true); // go get me the info :)
		setCaption( i18n("Fetching Autoreply for %1...").arg(mContact->displayName()));
	}
	else
		kdDebug(14110) << "[ICQUserReason] slotFetchInfo(); Ignore request to fetch Autoreply, NOT online!" << endl;
}

void ICQUserReason::slotReadInfo()
{
	kdDebug(14110) << "[ICQUserReason] slotReadInfo(); autoreply= " << mContact->mUser->AutoReply.c_str() << endl;
	setCaption(i18n("Autoreply for %1").arg(mContact->displayName()));
	mMainWidget->setDisabled( false );
	enableButton(User1,true);
	mTextEdit->setText( mProtocol->engine()->from8Bit(mContact->uin(), mContact->mUser->AutoReply.c_str()) );
}

#include "icquserreason.moc"
