/***************************************************************************
                          ircchatview.h  -  description
                             -------------------
    begin                : Sun Feb 24 2002
    copyright            : (C) 2002 by nbetcher
    email                : nbetcher@usinternet.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef IRCCHATVIEW_H
#define IRCCHATVIEW_H



#include "irc_view_base.h"

#include <qstring.h>



class IRCContact;

class KPopupMenu;

class QLineEdit;
class QListBox;
class QListBoxItem;
class QSplitter;



class IRCChatView : public IrcViewBase
{
	Q_OBJECT

public:

	IRCChatView(const QString &, const QString &, IRCContact *irccontact, QWidget *parent);

protected:

	virtual void closeEvent( QCloseEvent *e);

private slots:

	void incomingNamesList(const QString &channel, const QString &nickname, const int userClass);
	void userJoinedChannel(const QString &user, const QString &channel);
	void incomingMessage(const QString &originating, const QString &target, const QString &message);
	void slotReturnPressed();
	void userPartedChannel(const QString &user, const QString &channel, const QString &reason);
	void incomingAction(const QString &, const QString &, const QString &);
	void userQuitIRC(const QString &user, const QString &reason);
	void nickNameChanged(const QString &, const QString &);
	void incomingNewTopic(const QString &, const QString &, const QString &);
	void receivedExistingTopic(const QString &, const QString &);
	void incomingNoNickChan(const QString &);
	void slotPageChanged(QWidget *);
	void slotChangeTopic();
	void slotCloseTab();
	void incomingKick(const QString &user, const QString &channel, const QString &by, const QString &reason);
	void slotContextMenu( QListBoxItem *, const QPoint &);
	void slotOpenQuery();
	void slotDccChat();
	void slotDccSend();
	void slotPingUser();
	void slotVersionUser();
	void incomingNotice(const QString &, const QString &);
private:

	IRCContact *m_ircContact;
	QString m_channel;
	bool firstJoin;
	bool tryingPart;
	KPopupMenu *popup;
	KPopupMenu *ctcpMenu;
	KPopupMenu *dccMenu;
	QString onContact;

	QLineEdit* topicField;
	QSplitter* mainSplitter;
	QListBox* namesList;
};

#endif
/*
 * Local variables:
 * c-indentation-style: k&r
 * c-basic-offset: 8
 * indent-tabs-mode: t
 * End:
 */
// vim: set noet ts=4 sts=4 sw=4:

