/***************************************************************************
                          irccmdparser.h  -  description
                             -------------------
    begin                : Sun Apr 7 2002
    copyright            : (C) 2002 by nbetcher
    email                : nbetcher@usinternet.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
 
#ifndef IRCCMDPARSER_H
#define IRCCMDPARSER_H



#include <qstringlist.h>



class IRCProtocol;
class IRCServerContact;

class QTextEdit;



class IRCCmdParser
{
public:
	enum CommandType
	{
		Server = 0,
		Chat = 1,
		Query = 2
	};
	IRCCmdParser(IRCProtocol *protocol, IRCServerContact *contact);
	void parseCommand(QTextEdit *chatView, CommandType type, const QString &command, const QString &text, const QString &callingParent);
private:
	IRCServerContact *mContact;
	IRCProtocol *mProtocol;
	QStringList serverCommands;
	QStringList chatCommands;
	QStringList queryCommands;
};

#endif
/*
 * Local variables:
 * c-indentation-style: k&r
 * c-basic-offset: 8
 * indent-tabs-mode: t
 * End:
 */
// vim: set noet ts=4 sts=4 sw=4:

