/***************************************************************************
                          ircconsoleview.h  -  description
                             -------------------
    begin                : Sun Mar 24 2002
    copyright            : (C) 2002 by nbetcher
    email                : nbetcher@usinternet.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef IRCCONSOLEVIEW_H
#define IRCCONSOLEVIEW_H



#include "irc_view_base.h"

#include <qstring.h>
#include <qstringlist.h>



class IRCServerContact;

class KIRC;

class QLabel;



class IRCConsoleView : public IrcViewBase
{
Q_OBJECT
public:
	IRCConsoleView(const QString &server, KIRC *engine, IRCServerContact *mContact, QWidget *parent);

private:
	bool m_tryingQuit;
	QString m_serverName;
	KIRC *m_engine;
	IRCServerContact *m_ircServerContact;
	QStringList m_pendingConnection;
	QLabel* serverName;

private slots:
	void slotReturnPressed();
	void slotConnecting();
	void slotHostFound();
	void slotConnected();
	void slotConnectionClosed();
	void slotError(int);
	void slotIncomingSrvMsg(const QString &);
	void slotIncomingMotd(const QString &);
	void slotLoggedIn();
	void incomingNoNickChan(const QString &);
	void incomingUnknown(const QString &);
	void incomingWhoIsChannels(const QString &nickname, const QString &channel);
	void incomingWhoIsIdle(const QString &nickname, unsigned long seconds);
	void incomingWhoIsOperator(const QString &nickname);
	void incomingWhoIsUser(const QString &nickname, const QString &username, const QString &hostname, const QString &realname);
	void incomingWhoIsServer(const QString &nickname, const QString &server, const QString &serverInfo);
	void slotServerHasQuit();
	void slotPageChanged(QWidget *);
	void slotRepliedCtcp(const QString &, const QString &, const QString &);
	void slotCtcpReply(const QString &type, const QString &target, const QString &messageReceived);
	void slotCloseTab();
	void incomingNotice(const QString &, const QString &);
signals:
	void quitRequested();
};

#endif
/*
 * Local variables:
 * c-indentation-style: k&r
 * c-basic-offset: 8
 * indent-tabs-mode: t
 * End:
 */
// vim: set noet ts=4 sts=4 sw=4:

