/***************************************************************************
                          ircdccview.h  -  description
                             -------------------
    begin                : Fri Apr 19 2002
    copyright            : (C) 2002 by nbetcher
    email                : nbetcher@usinternet.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
 
#ifndef IRCDCCVIEW_H
#define IRCDCCVIEW_H



#include "irc_view_base.h"

#include <qstring.h>



class DCCClient;
class DCCServer;
class IRCServerContact;

class QVBox;



class IRCDCCView : public IrcViewBase
{
	Q_OBJECT

public:

	IRCDCCView(const QString &, IRCServerContact *contact, QVBox *layout, DCCClient *chatObject);
	IRCDCCView(const QString &nickname, IRCServerContact *contact, QVBox *layout, DCCServer *chatObject);

private slots:

	void incomingMessage(const QString &message, bool);
	void slotReturnPressed();
	void slotPageChanged(QWidget *);
	void slotCloseTab();
	void slotChatEnding();
	void slotConnected();
	void incomingNoNickChan(const QString &);

private:

	void createLayout();

	IRCServerContact *mContact;
	QVBox *mLayout;
	DCCClient *mChatObject;
	QString mNickname;
};

#endif
/*
 * Local variables:
 * c-indentation-style: k&r
 * c-basic-offset: 8
 * indent-tabs-mode: t
 * End:
 */
// vim: set noet ts=4 sts=4 sw=4:

