/***************************************************************************
                          ircservermanager.cpp  -  description
                             -------------------
    begin                : Wed Mar 6 2002
    copyright            : (C) 2002 by nbetcher
    email                : nbetcher@usinternet.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "ircservermanager.h"
#include "ircservercontact.h"
#include "ircprotocol.h"
#include "kirc.h"
#include <kdebug.h>

IRCServerManager::IRCServerManager()
{
	serverDict = new QDict<IRCServerContact>;
}

IRCServerContact *IRCServerManager::findServer(const QString &server)
{
	return serverDict->find(server);
}

IRCServerContact *IRCServerManager::addServer(const QString &contactString, bool connectNow, IRCProtocol *protocol)
{
	if (serverDict->find(contactString) == 0)
	{
		kdDebug(14120)<< "IRCServerManager::addServer : " << contactString <<endl;
		QStringList nickAndServer = QStringList::split("@", contactString);
		IRCServerContact *contact = new IRCServerContact(nickAndServer[1], nickAndServer[0], connectNow, protocol);
		serverDict->insert(contactString, contact);
		return contact;
	}
	return serverDict->find(contactString);
}

bool IRCServerManager::removeServer(const QString &contactServer)
{
	return serverDict->remove(contactServer);
}

bool IRCServerManager::linkServer(const QString &oldContactServer, const QString &newContactServer)
{
	IRCServerContact *contact = serverDict->find(oldContactServer);
	if (contact != 0)
	{
		serverDict->insert(newContactServer, contact);
		return true;
	}
	return false;
}

QStringList IRCServerManager::serverList()
{
	QStringList retVal;
	QDictIterator<IRCServerContact> it(*serverDict);
	for (; it.current(); ++it)
	{
		retVal.append(it.current()->serverName());
	}
	return retVal;
}

#include "ircservermanager.moc"
/*
 * Local variables:
 * c-indentation-style: k&r
 * c-basic-offset: 8
 * indent-tabs-mode: t
 * End:
 */
// vim: set noet ts=4 sts=4 sw=4:

