#ifndef TABCOMPLETER_H
#define TABCOMPLETER_H



#include <qlineedit.h>

#include "irchistory.h"

#include <qstringlist.h>



class TabCompleter : public QLineEdit
{
Q_OBJECT
public:
	TabCompleter(QWidget *parent, const char *name = "TabCompleter");

public slots:
	void setCompletions(const QStringList &words) { mWords=words; }
	void add(const QString &name);
	void remove(const QString &name);

protected:
	void keyPressEvent(QKeyEvent *e);
	bool event(QEvent *e);

private:
	QStringList mWords;
	IRCHistory mHistory;
	int pos, len, lenNew, inc;
};

#endif
/*
 * Local variables:
 * c-indentation-style: k&r
 * c-basic-offset: 8
 * indent-tabs-mode: t
 * End:
 */
// vim: set noet ts=4 sts=4 sw=4:

