/***************************************************************************
                          dccconfirm.cpp  -  description
                             -------------------
    begin                : Sat Apr 20 2002
    copyright            : (C) 2002 by nbetcher
    email                : nbetcher@usinternet.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/



#include "dccconfirm.h"

#include <klocale.h>

#include <qlabel.h>
#include <qpushbutton.h>



DCCConfirm::DCCConfirm(QWidget *parent)
	: DCCConfirmBase(parent)
{

}

bool DCCConfirm::confirmRequest(DCCConfirm::DCCType type, const QString &nickname, const QString &filename, unsigned int size, QWidget *parent)
{
	DCCConfirm confirm(parent);
	QObject::connect(confirm.cmdAccept, SIGNAL(clicked()), &confirm, SLOT(slotAccept()));
	QObject::connect(confirm.cmdDeny, SIGNAL(clicked()), &confirm, SLOT(slotDeny()));
	switch (type)
	{
		case DCCConfirm::Chat:
		{
			confirm.incomingMessage->setText(i18n("Incoming DCC CHAT Request:"));
			confirm.detailsMessage->setText(i18n("<qt>The user %1 is requesting a DCC CHAT connection with you. DCC CHATs are direct connections between two computers that only allow raw messages to be sent, with no throttle.</qt>").arg(nickname));
			break;
		}
		case DCCConfirm::Send:
		{
			confirm.incomingMessage->setText(i18n("Incoming DCC SEND Request:"));
			confirm.detailsMessage->setText(i18n("<qt>The user %1 wants to send the filename \"%2\" to you with the size of \"%3\" megabytes ( %4 bytes ). The file will not be executed at any point.</qt>").arg(nickname).arg(filename).arg((size / 1024) / 1000).arg(size));
			break;
		}
	}
	if (confirm.exec())
	{
		return true;
	} else {
		return false;
	}
}

void DCCConfirm::slotAccept()
{
	accept();
}

void DCCConfirm::slotDeny()
{
	reject();
}

#include "dccconfirm.moc"
/*
 * Local variables:
 * c-indentation-style: k&r
 * c-basic-offset: 8
 * indent-tabs-mode: t
 * End:
 */
// vim: set noet ts=4 sts=4 sw=4:

