
#include "irc_channel_tabwidget.h"
#include "ircchatwindow.h"
#include "ircservercontact.h"
#include <qaccel.h>
#include <qlayout.h>
#include <qtabwidget.h>
#include <qevent.h>
#include <klocale.h>
#include <ktoolbar.h>
#include <qvbox.h>
#include <kdebug.h>



IRCChatWindow::IRCChatWindow(QString serverText, IRCServerContact *contact)
	: KMainWindow()
{
	mContact = contact;
	resize(800, 600);
	QVBox *parent = new QVBox(this);
	mToolBar = toolBar();
	mTabWidget = new IrcChannelTabWidget(parent);
	// Make this configurable:
	mTabWidget->setTabPosition(QTabWidget::Bottom);
	setCentralWidget(parent);
	setCaption(serverText);

	// Shortcuts for the IrcChannelTabWidget

        QAccel* pAccel(new QAccel(this));
	pAccel->connectItem(pAccel->insertItem(Qt::ALT + Key_Left),
			    mTabWidget,
			    SLOT(slotPrevPage()));
	pAccel->connectItem(pAccel->insertItem(Qt::ALT + Key_Right),
			    mTabWidget,
			    SLOT(slotNextPage()));
}

IRCChatWindow::IRCChatWindow()
	: KMainWindow()
{
	resize(800, 600);
	QVBox *parent = new QVBox(this);
	mToolBar = toolBar();
	mTabWidget = new IrcChannelTabWidget(parent);
	// Make this configurable:
	mTabWidget->setTabPosition(QTabWidget::Bottom);
	setCentralWidget(parent);
}

IRCChatWindow::~IRCChatWindow()
{
	kdDebug(14120) << k_funcinfo << endl;
}

void IRCChatWindow::closeEvent(QCloseEvent *e)
{
	kdDebug(14120) << "closeEvent() mContact == " << mContact << endl;
	if (mContact != 0)
	{
		if (mContact->parentClosing() == true)
		{
			e->accept();
			delete mContact;
			QWidget::closeEvent(e);
			return;
		}
		e->ignore();
		kdDebug(14120) << "parentClosing returned false" << endl;
	} else {
		QWidget::closeEvent(e);
	}
}
#include "ircchatwindow.moc"
/*
 * Local variables:
 * c-indentation-style: k&r
 * c-basic-offset: 8
 * indent-tabs-mode: t
 * End:
 */
// vim: set noet ts=4 sts=4 sw=4:

