/***************************************************************************
                          ircqueryview.h  -  description
                             -------------------
    begin                : Tue Apr 2 2002
    copyright            : (C) 2002 by nbetcher
    email                : nbetcher@usinternet.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef IRCQUERYVIEW_H
#define IRCQUERYVIEW_H

#include "irc_view_base.h"

#include <qstring.h>

class IRCContact;
class IRCServerContact;

class IRCQueryView : public IrcViewBase
{
	Q_OBJECT
public:
	IRCQueryView(const QString &, const QString &, IRCServerContact *contact, QWidget *parent, IRCContact *mainContact);
	~IRCQueryView();
private slots:
	void incomingMessage(const QString &originating, const QString &target, const QString &message);
	void slotReturnPressed();
	void incomingAction(const QString &, const QString &, const QString &);
	void incomingNoNickChan(const QString &);
	void slotPageChanged(QWidget *);
	void slotCloseTab();
	void slotConnected();
	void slotServerQuit();
	void slotServerReady();
	void incomingNotice(const QString &, const QString &);
private:
	void createLayout();
	IRCServerContact *m_serverContact;
	QString m_nickname;
	IRCContact *m_ircContact;
};

#endif
/*
 * Local variables:
 * c-indentation-style: k&r
 * c-basic-offset: 8
 * indent-tabs-mode: t
 * End:
 */
// vim: set noet ts=4 sts=4 sw=4:

