 /*
    jabbermap.h

    Copyright (c) 2002 by Till Gerken <till@tantalo.net>

    Kopete    (c) 2002 by the Kopete developers  <kopete-devel@kde.org>

    *************************************************************************
    *                                                                       *
    * This program is free software; you can redistribute it and/or modify  *
    * it under the terms of the GNU General Public License as published by  *
    * the Free Software Foundation; either version 2 of the License, or     *
    * (at your option) any later version.                                   *
    *                                                                       *
    *************************************************************************
*/

#ifndef JABBERMAP_H
#define JABBERMAP_H

#include <qmap.h>

/**
  *@author Till Gerken
  */

template<class Key, class T> class JabberMap : public QMap<Key, T>
{

	public:
		typedef QMapConstIterator<Key,T> JabberMapConstIterator;
		
		const Key & operator[] (T &val) const
		{
			for(JabberMapConstIterator i = begin(); i != end(); ++i)
			{
				if(i.data() == val)
					return i.key();
			}
			// FIXME: need to return an invalid key here!
		}
		
		bool contains(const T &val) const
		{
			for(JabberMapConstIterator i = begin(); i != end(); ++i)
			{
				if(i.data() == val)
					return true;
			}
			return false;
		}
};

#endif
