 /*
    jabbermessagemanager.h

    Copyright (c) 2002 by Till Gerken <till@tantalo.net>

    Kopete    (c) 2002 by the Kopete developers  <kopete-devel@kde.org>

    *************************************************************************
    *                                                                       *
    * This program is free software; you can redistribute it and/or modify  *
    * it under the terms of the GNU General Public License as published by  *
    * the Free Software Foundation; either version 2 of the License, or     *
    * (at your option) any later version.                                   *
    *                                                                       *
    *************************************************************************
*/

#ifndef JABBERMESSAGEMANAGER_H
#define JABBERMESSAGEMANAGER_H

#include <qwidget.h>

#include "psi/libpsi/src/types.h"
#include "psi/libpsi/src/message.h"

#include "kopetecontact.h"
#include "kopetemessagemanager.h"

/**
  *@author Kopete developers
  */

class JabberMessageManager : public KopeteMessageManager
{

	Q_OBJECT

public: 

	JabberMessageManager(const KopeteContact *user, KopeteContactPtrList others,
						 const KopeteMessageManager::WidgetType type, const char *name = 0 );

	~JabberMessageManager();

	KopeteContact *getContact(const QString &name);
	
public slots:
	void removeContact(const QString &name);

private slots:
	void slotMessageSent(const KopeteMessage &message, KopeteMessageManager *);

private:
	void km2jm(const KopeteMessage &km, Jabber::Message &jm);

};

#endif
