 /*
    jabberprefs.h

    Copyright (c) 2002 by Daniel Stone <dstone@kde.org>

    Kopete    (c) 2002 by the Kopete developers  <kopete-devel@kde.org>

    *************************************************************************
    *                                                                       *
    * This program is free software; you can redistribute it and/or modify  *
    * it under the terms of the GNU General Public License as published by  *
    * the Free Software Foundation; either version 2 of the License, or     *
    * (at your option) any later version.                                   *
    *                                                                       *
    *************************************************************************
*/

#ifndef JABBERPREFS_H
#define JABBERPREFS_H

#include <configmodule.h>

class DlgJabberPrefs;
class JabberProtocol;

/**
  *@author Daniel Stone
  */

class JabberPreferences : public ConfigModule
{
	Q_OBJECT

	public:
		JabberPreferences(const QString &pixmap, JabberProtocol *parent);
		~JabberPreferences();

		virtual void save();

	public slots:	
		virtual void reopen();
		
	signals:
		void saved();

	private:
		DlgJabberPrefs *preferencesDialog;
		JabberProtocol *protocol;

};

#endif
/*
 * Local variables:
 * c-indentation-style: k&r
 * c-basic-offset: 8
 * indent-tabs-mode: t
 * End:
 */
// vim: set noet ts=4 sts=4 sw=4:
