#ifndef CONSOLE_H
#define CONSOLE_H

#include<qobject.h>
#include<qstring.h>
#include<sys/termios.h>

class Console : public QObject
{
	Q_OBJECT

public:
	Console(const QString &);
	~Console();

	void setPrompt(const QString &);
	void erasePrompt();
	void reshowPrompt();

	void append(const QString &);

signals:
	void command(const QString &);

private slots:
	void eventloop();

private:
	QString prompt;
	int needprompt;

	int index;
	char cmdline[256];
	QString cmd;

	void con_init();
	void con_deinit();
	int con_getch();
	int con_kbhit();

	struct termios old_term_attr;
};

#endif
