#ifndef JABBERTEST_H
#define JABBERTEST_H

#include<qobject.h>

#include"console.h"
#include"client.h"
#include"tasks.h"

using namespace Jabber;

class JabberTest : public QObject
{
	Q_OBJECT

public:
	JabberTest();
	~JabberTest();

signals:
	void quit();

private slots:
	void doCommand(const QString &);
	void bail();
	void clientDebug(const QString &);
	void clientError(const StreamError &);
	void clientCloseFinished();
	void clientHandshaken();
	void clientResourceAvailable(const Jid &, const Resource &);
	void clientResourceUnavailable(const Jid &, const Resource &);
	void clientMessageReceived(const Message &);
	void authFinished(bool, int, const QString &);
	void rosterRequestFinished(bool, int, const QString &);
	void changePasswordFinished();

private:
	void displayRoster(int);

	Console *console;
	Client *client;
	QString host, user, pass;
	bool use_debug;
};

#endif

