/***************************************************************************
                        dlgjabberstatus.cpp  -  Jabber status dialog
                             -------------------
    begin                : Fri Apr 12 2002
    copyright            : (C) 2002 by Daniel Stone, Till Gerken,
                           Kopete Development team
    email                : dstone@kde.org, till@tantalo.net
 ***************************************************************************

 ***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qlayout.h>
#include <qlineedit.h>
#include <qlabel.h>
#include <qpushbutton.h>
#include <qspinbox.h>
#include <qstring.h>

#include <kdebug.h>
#include <klocale.h>
#include <kcombobox.h>

#include "kopeteaway.h"
#include "dlgpreferences.h"
#include "dlgjabberstatus.h"
#include "dlgstatus.h"
#include "jabberprotocol.h"

dlgJabberStatus::dlgJabberStatus(JabberProtocol *owner, int status, QWidget *parent, const char *name) : dlgStatus(parent, name)
{

	plugin = owner;

	connect(btnFinish, SIGNAL(clicked()), this, SLOT(slotFinish()));
	connect(btnCancel, SIGNAL(clicked()), this, SLOT(slotCancel()));

	switch(status)
	{
		case JabberProtocol::STATUS_AWAY:
							mStatus = JabberProtocol::STATUS_AWAY;
							lblRealStatus->setText(i18n("Away"));
							leReason->setText(i18n("I'm away; back in a bit."));
							break;

		case JabberProtocol::STATUS_XA:
							mStatus = JabberProtocol::STATUS_XA;
							lblRealStatus->setText(i18n("Extended Away"));
							leReason->setText(i18n("Sorry, stepped out for a bit. Be back later."));
							break;

		case JabberProtocol::STATUS_DND:
							mStatus = JabberProtocol::STATUS_DND;
							lblRealStatus->setText(i18n("Do Not Disturb"));
							leReason->setText(i18n("Sorry, I'm busy right now."));
							break;

		case JabberProtocol::STATUS_ONLINE:
							mStatus = JabberProtocol::STATUS_ONLINE;
							lblRealStatus->setText(i18n("Online"));
							leReason->setText(i18n("Talk to me if you want."));
							break;
	}

	cbAway->insertStringList(KopeteAway::getInstance()->getTitles());

	connect(cbAway, SIGNAL(activated(const QString &)), this, SLOT(slotChangeReason(const QString &)));
	
	show();

}

dlgJabberStatus::~dlgJabberStatus()
{

}

void dlgJabberStatus::slotChangeReason(const QString &title)
{

	leReason->setText(KopeteAway::getInstance()->getMessage(title));

}

void dlgJabberStatus::slotFinish()
{
	// this is a hack, gcc didn't want to compile without this
	// temporary copy
	QString blah = leReason->text();
	
	plugin->setPresence(mStatus, blah);
	hide();

}

void dlgJabberStatus::slotCancel()
{

	hide();

}

#include "dlgjabberstatus.moc"
/*
 * Local variables:
 * c-indentation-style: k&r
 * c-basic-offset: 8
 * indent-tabs-mode: t
 * End:
 */
// vim: set noet ts=4 sts=4 sw=4:

