/*
	msnidentity.h - Manages a single MSN identity

	Copyright (c) 2002 by Martijn Klingens       <klingens@kde.org>
	          (c) 2002 by Duncan Mac-Vicar Prett <duncan@kde.org>

	Portions of this code are taken from KMerlin,
	          (c) 2001 by Olaf Lueg              <olueg@olsd.de>

	*************************************************************************
	*                                                                       *
	* This program is free software; you can redistribute it and/or modify  *
	* it under the terms of the GNU General Public License as published by  *
	* the Free Software Foundation; either version 2 of the License, or     *
	* (at your option) any later version.                                   *
	*                                                                       *
	*************************************************************************
*/

#ifndef MSNIDENTITY_H
#define MSNIDENTITY_H

#include <qobject.h>

class MSNProtocol;

/**
 * MSNIdentity encapsulates everything that is identity-based, as opposed to
 * protocol based. This basically means sockets, current status, and account
 * info are stored in the identity, whereas the protocol is only the
 * 'manager' class that creates and manages identities.
 */
class MSNIdentity : public QObject
{
	Q_OBJECT

public:
	MSNIdentity( MSNProtocol *parent, const char *name );
	~MSNIdentity();
};

#endif



/*
 * Local variables:
 * c-indentation-style: k&r
 * c-basic-offset: 8
 * indent-tabs-mode: t
 * End:
 */
// vim: set noet ts=4 sts=4 sw=4:

