/*
    oscaruserinfo.h  -  Oscar Protocol Plugin

    Copyright (c) 2002 by Tom Linsky <twl6@po.cwru.edu>

    Kopete    (c) 2002 by the Kopete developers  <kopete-devel@kde.org>

    *************************************************************************
    *                                                                       *
    * This program is free software; you can redistribute it and/or modify  *
    * it under the terms of the GNU General Public License as published by  *
    * the Free Software Foundation; either version 2 of the License, or     *
    * (at your option) any later version.                                   *
    *                                                                       *
    *************************************************************************
*/

#ifndef OSCARUSERINFO_H
#define OSCARUSERINFO_H

#include "oscarinfobase.h"
#include "oscarsocket.h"

class KTextBrowser;
class OscarProtocol;
class AIMBuddy;

class OscarUserInfo : public OscarUserInfoBase
{
Q_OBJECT
public:
/**
 * This constructor is used to show the user info
 * for a contact
 */ 
	OscarUserInfo(const QString name, const QString nick,
			OscarProtocol *protocol, AIMBuddy &buddy);
/**
 * This constructor is called when we want to edit our
 * own profile
 */
	OscarUserInfo(const QString name, const QString nick,
			OscarProtocol *protocol, const QString &profile);
private:
	QString mNick;
	OscarProtocol *mProtocol;
	QString mName;
private slots:
	void slotSaveClicked();
	void slotCloseClicked();
	void slotSearchFound(UserInfo, QString);
signals:
	void updateNickname(const QString);
};

#endif

