/*
    oscardebugdialog.cpp  -  Oscar Protocol Plugin

    Copyright (c) 2002 by Christopher TenHarmsel
		          <tenharmsel@users.sourceforge.net>
		
    (c) 2002 by the Kopete developers  <kopete-devel@kde.org>

    *************************************************************************
    *                                                                       *
    * This program is free software; you can redistribute it and/or modify  *
    * it under the terms of the GNU General Public License as published by  *
    * the Free Software Foundation; either version 2 of the License, or     *
    * (at your option) any later version.                                   *
    *                                                                       *
    *************************************************************************
*/

#include "oscardebugdialog.h"
#include "oscardebugdialog.moc"
#include <qtextedit.h>
#include <qpushbutton.h>

OscarDebugDialog::OscarDebugDialog(QWidget* parent, const char *name)
		: DebugDialog(parent, name){
	
	// Connect the slots
	QObject::connect(btnClose, SIGNAL(clicked()),
			this, SLOT(slotClose()));
	QObject::connect(btnClear, SIGNAL(clicked()),
			this, SLOT(slotClearDisplay()));

	// Set the text format
	txtOscarData->setTextFormat(RichText);
	
}

OscarDebugDialog::~OscarDebugDialog(){
	// Nothing
}

void OscarDebugDialog::addMessageFromServer(QString message, QString connName){
	txtOscarData->append("<font color='#0000cc'>Incoming: (" + connName + ") </font>");
	txtOscarData->append(message);
}

void OscarDebugDialog::addMessageFromClient(QString message, QString connName){
	txtOscarData->append("<font color='#cc0000'>Outgoing: (" + connName + ") </font>");
	txtOscarData->append(message);
}

void OscarDebugDialog::slotClose(){
	// Close the dialog
	close();
}

void OscarDebugDialog::slotClearDisplay(){
	txtOscarData->clear();
}

void OscarDebugDialog::slotSave(){
	// Save the text to a file
	// TODO Implement me
}

