/*
    oscardebugdialog.h  -  Oscar Protocol Plugin

    Copyright (c) 2002 by Christopher TenHarmsel
		          <tenharmsel@users.sourceforge.net>
		
    (c) 2002 by the Kopete developers  <kopete-devel@kde.org>

    *************************************************************************
    *                                                                       *
    * This program is free software; you can redistribute it and/or modify  *
    * it under the terms of the GNU General Public License as published by  *
    * the Free Software Foundation; either version 2 of the License, or     *
    * (at your option) any later version.                                   *
    *                                                                       *
    *************************************************************************
*/

#ifndef OSCARDEBUGDIALOG
#define OSCARDEBUGDIALOG

#include "debugdialog.h"

/**
 * This is just a simple dialog that will allow you to
 * view the communications between the server and the
 * client.
 */
class OscarDebugDialog : public DebugDialog {
	Q_OBJECT
		
	public:
	OscarDebugDialog(QWidget* parent = 0, const char *name = 0);
	virtual ~OscarDebugDialog();

	/**
	 * Adds a message from the server to the
	 * display.
	 */
	void addMessageFromServer(QString message, QString connName);
	/**
	 * Adds a message fromt he client to the
	 * display.
	 */
	void addMessageFromClient(QString message, QString connName);

	
	public slots:
	/**
	 * Clears the text display
	 */
	void slotClearDisplay();

	/**
	 * Closes the dialog
	 */
	void slotClose();

	/**
	 * Saves the current text out to
	 * a file
	 */
	void slotSave();
	
};

#endif
