#include "smsglobal.h"
#include "smscontact.h"

#include <kglobal.h>
#include <kconfig.h>

QString SMSGlobal::readConfig(QString group, QString name, SMSContact* contact)
{
	QString s = QString::null;

	if (contact != 0L)
	{
		if (group == "SMS" && name == "ServiceName")
			s = contact->serviceName();
		else
			s = contact->servicePref(name);
	}

	if (s.isNull())
	{
		KGlobal::config()->setGroup(group);
		s = KGlobal::config()->readEntry(name, QString::null);
	}

	return s;

}

void SMSGlobal::writeConfig(QString group, QString name, SMSContact* contact, QString value)
{
	if (contact != 0L)
	{
		if (group == "SMS" && name == "ServiceName")
			contact->setServiceName(value);
		else
			contact->setServicePref(name, value);
	}
	else
	{
		KGlobal::config()->setGroup(group);
		KGlobal::config()->writeEntry(name, value);
		KGlobal::config()->sync();
	}
}

void SMSGlobal::deleteConfig(QString group, QString name, SMSContact* contact)
{
	if (contact != 0L)
	{
		contact->deleteServicePref(name);
	}
	else
	{
		KGlobal::config()->setGroup(group);
		KGlobal::config()->deleteEntry(name);
	}
}
